#!/bin/ksh
##############################################################################################################
#Script para executar o script .gs que cria binarios a partir da leitura do grads com os dados WRF.
#
#Uso do script .gs: grads -blc "run write_vars_posWRF.gs ${TEMPO} ${CTL} ${SAIDA_ARQUIVO_BINAR}"
#
#Para a verificacao do binario criado foi adaptado o arquivo .ctl (saidavar.ctl). 
#E como havia dado erros no display por causa do valor do undef, foi consertado verificando com os comandos:
#set gxout grid
#set lat -20 -19.9
#set lon -90.7 -90.5
#Foi aproximado o display e viu-se o valor do undef e adicionou no .ctl
#
#Essa versao foi rodada com os dados do pos divididos pelo tempo de analise/previsao (rodando no caso para 13
#arquivos a todo instante). 
#
#Data: 22/06/2015
#Ultima atualização: 26/06/2015
#Manutencao: Lucas Amarante
#
#Ultima rodada:14/08/2015
#Versao:Para os dados do EXP4 do gdad -> /stornext/online6/assim_dados/gdad/RMS/EXP04/atm/WRF
##############################################################################################################
 echo "Nao esquecer de carregar o modulo grads: module load grads!"

   #dirWRF=/stornext/online6/assim_dados/lucas.amarante/WRF_pos/dataIN        #original   
#   dirWRF=/scratchin/grupos/assim_dados/home/lucas.amarante/EXP4_WRF_POS/WRF/dataout
#   dirWRF=/stornext/online6/das/gdad/RMS/EXP04/atm/WRF/dataout
   dirWRF=/stornext/online6/das/thamiris.campos/5-cycle3h-lambert-completo/WRF/dataout-3km-cnt/
dirOUTwrf=/stornext/home/luiz.sapucci/test/dataout
      run=/stornext/home/luiz.sapucci/test

caldate=/stornext/home/luiz.sapucci/scripts/caldate.3.1.2

datai=2011060700
dataf=2011060700

data=${datai}

echo $caldate $dirWRF

ls $dirWRF/${data}

while [ ${data} -le ${dataf} ]
do

   echo -e "\033[34;1m Época:  ${data} \033[m"

   ano=`echo ${data} | cut -c1-4`
   mes=`echo ${data} | cut -c5-6`
   dia=`echo ${data} | cut -c7-8`
   hor=`echo ${data} | cut -c9-10`   
   
   mkdir -p ${dirOUTwrf}/${data}
   
   cd ${dirWRF}/${data}
#   arqCTL=wrfpos_d01_${ano}-${mes}-${dia}_${hor}:00:00.ctl
#   arqDAT=wrfpos_d01_${ano}-${mes}-${dia}_${hor}:00:00.dat
   arqCTL=WRF_cpt_03KM_${data}.ctl
   arqDAT=WRF_cpt_03KM_${data}+${data}.grb2
      
   if [ -e ${arqCTL} ] && [ -e ${arqDAT} ]; then

     echo " ::: Executando :::"
     echo "Dados utilizados:" 
     echo " ${arqDAT}"
     echo " ${arqCTL}"
     
     qntTDEF=`grep "tdef" ${arqCTL} | awk '{print $2}'`  #tdef
     tmpPREV=`grep "tdef" ${arqCTL} | awk '{print $NF}'` #tempo previsao
     
     qprev=`echo ${tmpPREV%hr}` #retirando MN do result variavel
     
     cnvhora=$qprev #result em horas

     outbinar=`echo ${arqDAT%.dat}` #nome do binario sem extensao

     echo " "     
     echo "Parametros: "
     echo "TDEF:    ${qntTDEF}"
     echo "Arq CTL: ${dirWRF}/${data}/${arqCTL}"
     echo "dirOUT:  ${dirOUTwrf}/${data}/${outbinar}"
     echo " "
     echo " " 
     echo ":::::: Executando grads gs ::::::"

     #executa o gs
     parametro="'run ${run}/write_vars_posWRF.gs ${qntTDEF} ${dirWRF}/${data}/${arqCTL} ${dirOUTwrf}/${data}/${outbinar}'"
 #    grads -blc ${parametro} 
          
     echo " "
     echo " " 
     #modifica nome dos arquivos
     echo "Modificando nome dos arquivos de saida:"
     
     cd ${dirOUTwrf}/${data}
     
     \ls WRF_cpt_03KM_${data}* | while read tbin
     do
     
        timeinicbinar=${data}
        #coletando valor no final do arquivo {1t..a..13t}
        finarqout=`echo ${tbin:40}` 
        finarqout2=`echo ${tbin:24}` 
                
        t=`echo ${finarqout%t}`
        tt=`echo "$t - 1 " | bc `
                        
        echo "Realizando para o arquivo: ${tbin}" 

      	tdefdata=`$caldate ${data} + ${tt}h 'yyyymmddhh'`
       	trechofinal=${tdefdata}.grb            
        
        echo "$somahora - $tdefdata - $trechofinal"
        
        newtbin=`echo ${tbin} | sed "s/${finarqout2}/${trechofinal}/g"`
            
        mv ${tbin} ${newtbin}
            
        echo "Nova saida do nome binario: "
        echo "${newtbin}"
        echo " "
     
     done
     
     
   else
     echo "Arquivos .DAT ou .CTL nao existem!"
   fi 
   
 

  data=`$caldate ${data} + 06h 'yyyymmddhh'`
done

